

#ifndef BJ_AIRPLAY_ITF_H_
#define BJ_AIRPLAY_ITF_H_

#include <stdint.h>
#include <stdarg.h>

#include <jni.h>

#ifdef BJ_AIRPLAY_EXPORTS
#define BJ_AIRPLAY_API
#else
#define BJ_AIRPLAY_API __attribute__((visibility ("default")))
#endif

//BJ_AIRPLAY_FLAGS
#define BJ_AIRPLAY_SUPPORT_ROTATION_FLAG (0x00000001)
#define BJ_AIRPLAY_SUPPORT_URL_FLAG (0x00000002)
#define BJ_AIRPLAY_SUPPORT_MBNAUL_FLAG (0x00000004)
#define BJ_AIRPLAY_DISABLE_MBNAUL_FLAG (0x00000008)
#define BJ_AIRPLAY_SUPPORT_SPSPPSNAUL_FLAG (0x00000010)


typedef enum
{
    BJAir_Resolution_1080P = 0,
    BJAir_Resolution_720P = 1,
    BJAir_Resolution_800x600 = 2,
    BJAir_Resolution_1600x900 = 3,
    BJAir_Resolution_2560x1440 = 4,
    BJAir_Resolution_3840x2160 = 5,
    BJAir_Resolution_Button
}BJAirResolutionType;

typedef enum
{
    BJAir_RepublishType_Normal = 0,
    BJAir_RepublishType_Remove_And_Publish = 1,
    BJAir_RepublishType_Button
}BJAirRepublishType;

typedef struct BJAirPlayAbility
{
    int maxFPS;
    int resolution_type; //ȡֵΧοBJAirResolutionType
}BJAirPlayAbility;

typedef enum {
    BJAir_LOG_CRIT = 1,
    BJAir_LOG_ERROR,
    BJAir_LOG_WARN,
    BJAir_LOG_INFO,
    BJAir_LOG_DEBUG,
    BJAir_LOG_DETAIL,
    BJAir_LOG_MAX,
}BJAirplayLogLevel;


typedef struct {
	/** ʼͶ
	*
	*     ʼ񲥷ŻỰûͶURLŻص񲥷ŵȳᴥýӿڡ
	*     @param playerId  ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param ip 豸IPַ
	*     @param device_model 豸豸ͺţiphone6
	*     @param device_name 豸豸
	*     @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	*     @note   ӦҪסplayerIdplayerIdάỰؽӿڶֶͨνй
	*/
	int32_t (*OnStartMirrorPlayer)(uint32_t playerId, const char* ip, const char* device_model, const char* device_name);

	/**
	* \brief           Write mirror audio PCM frame to player.
	* \param bitsdep   bitsdep of audio, 16 is default.
	* \param channels  channels of audio, 2 is default.
	* \param sampleRate sampleRate of audio, 44100 is default. .
	* \return          void
	*/
	void (*NotifyMirrorAudioCodecInfo)(uint32_t playerId, int32_t bitsdep, int32_t channels, int32_t sampleRate);

	/** ֪ͨӦþƵ
	*
	*     ͶУSDKյƵݺн룬øýӿ֪ͨӦòѾPCMƵݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src   ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	uint32_t(*OnMirrorAudioData)(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);

	/** ֪ͨӦþƵ
	*
	*     ͶУSDKյƵݺøýӿ֪ͨӦòյH264Ƶݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @see    NotifyMirrorAudioCodecInfo()  ƵĲϢͨNotifyMirrorAudioCodecInfo֪ͨӦ
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	uint32_t(*OnMirrorVideoData)(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);

	/** 񲥷ƵתǶ֪ͨ
	*
	*     IPAD/IPHONEն
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param angle ƵתǶȣȡֵΧΪ0,90,180,270нǶΪ˳ʱ뷽Ƕȡ
	*     @return    
	*     @note   Ӧյ¼󣬲ҪݸýǶתȷʾƵ
	*/
	void(*OnRotateMirrorVideo)(uint32_t playerId, int angle);

	/** ֹͣ񲥷
	*
	*     ֹͣ񲥷ŻỰûֹͣͶɾͶлURLŵȳᴥýӿڡ
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @return    
	*     @note   ӦҪͷŸûỰԴ
	*/
	void(*OnStopMirrorPlayer)(uint32_t playerId);


	/** 
	*
	*     ֹͣ񲥷ŻỰûֹͣͶɾͶлURLŵȳᴥýӿڡ
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param volumePercent,,0: 100:
	*     @return    
	*     @note   ӦҪͷŸûỰԴ
	*/
	void(*SetVolume)(uint32_t playerId, int volumePercent);


	/** ʼƵ
	*
	*     ʼ񲥷ŻỰûͶURLŻص񲥷ŵȳᴥýӿڡ
	*     @param playerId  ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param ip 豸IPַ
	*     @param device_model 豸豸ͺţiphone6
	*     @param device_name 豸豸
	*     @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	*     @note   ӦҪסplayerIdplayerIdάŻỰؽӿڶֶͨνй
	*/
	int32_t(*OnStartAudioPlayer)(uint32_t playerId, const char* ip, const char* device_model, const char* device_name);

	/** ֪ͨƵʱķͼƬ
	*
	*     ƵʱǰŵֵķͼƬJPEGʽ
	*     @param playerId  ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src JPEGͼƬ
	*     @param size JPEGͼƬݳ
	*     @note   ӦӦýͼƬ־ûļг֡androidδʵ
	*/
	void(*RefreshCoverArtFromBuffer)(uint32_t playerId, const uint8_t *p_src, int size);



    /** ֪ͨƵʱalbum,title,artist
     * \brief         Refresh audio ID3 information on UI.
     * The function may not be necessary.
     *
     * \param album   The audio album.
     * \param title   The audio title.
     * \param artist  The audio artist.
     * \return        void
     */
    void(*RefreshTrackInfo)(uint32_t playerId, const char* album, const char* title, const char* artist);


	/** ֪ͨӦƵ
	*
	*     ƵͶУSDKյƵݺн룬øýӿ֪ͨӦòѾPCMƵݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src   ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	uint32_t(*OnAudioData)(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);


	/** ֹͣƵ
	*
	*     ֹͣ񲥷ŻỰûֹͣͶɾͶлURLŵȳᴥýӿڡ
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @return    
	*     @note   ӦҪͷŸûỰԴ
	*/
	void(*OnStopAudioPlayer)(uint32_t playerId);

	/** ֲ֪ͨʱƵݵĸʽ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param bitsdep   bitsdep of audio, 16 is default.
	* @param channels  channels of audio, 2 is default.
	* @param sampleRate sampleRate of audio, 44100 is default. .
	* @return          void
	*/
	void(*NotifyAudioCodecInfo)(uint32_t playerId, int32_t bitsdep, int32_t channels, int32_t sampleRate);

	/** ʼURLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param url	   ҪŵƵURL
	* @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	*/
	int32_t(*OnStartVideoPlayback)(uint32_t playerId, const char* ip, const char *url);

	/** URLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return    void
	* @note   ӦӦͷŲԴ
	*/
	void(*OnStopVideoPlayback)(uint32_t playerId);

	/** URLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return    void
	* @note   ӦӦͷŲԴ
	*/
	void(*OnPauseVideoPlayback)(uint32_t playerId);

	/** URLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return    void
	* @note   ͣ
	*/
	void(*OnResumeVideoPlayback)(uint32_t playerId);

	/** URLƵSeek
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param position_sec϶λãλ
	* @return    void
	* @note   ϶ڼ벥
	*/
	void(*OnSeekVideoBySec)(uint32_t playerId, int64_t position_sec);

	/** ȡURLǰλ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return int32_t ǰŵλãλΪ
	* @note   صǰŵλãλΪ
	*/
	int32_t(*OnGetVideoPositionMSec)(uint32_t playerId);

    /** ȡǰĲ״̬
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return int32_t ȡֵΧοBJAirPlayerStatus
	* @note
	*/
    int32_t(*OnGetVideoPlayerStatus)(uint32_t playerId);

	/** ȡURLʱ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return int32_t ȡURLʱλΪ
	* @note
	*/
	int32_t(*OnGetVideoDurationMSec)(uint32_t playerId);

	/**ʼ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param ip 豸IPַ
	* @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	* @note  ios9ǰϵͳ֧
	*/
	int32_t(*OnStartPhotoPlayer)(uint32_t playerId, const char* ip);

	/**ʼ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param picData, ָͼƬݵָ
	* @param size, ݵĴС
	* @return void
	* @note ios9ǰϵͳ֧
	*/
	void(*OnPlayPhoto)(uint32_t playerId, const uint8_t* picData, int size);

	/**
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return void
	* @note ios9ǰϵͳ֧
	*/
	void(*OnStopPhotoPlayer)(uint32_t playerId);

	/**ʾPIN
	* @param ip
	* @param pincode
	* @return void
	* @note
	*/
	void(*OnShowPinCode)(const char* ip,const char* pincode);

	/**PIN֤ɹ
	* @param ip
	* @return void
	* @note
	*/
	void(*OnVerifyPinSuccess)(const char* ip);

    /**ĳ˷ͶʱSDKصýӿڣȡ֡ʺͷֱʲ
	* @param ip
	* @return void
	* @note
	*/
    void(*OnProbePlayerAbility)(const char* ip, BJAirPlayAbility* const ability);

    /**ûԶ־ӿ
	* @param level
	* @return void
	* @note
	*/
    void(*LogFun)(unsigned int level, const char *format,  va_list argp);
} BJAirplayFunctionCbs_t;

/**
* BJAirplay Sdkĳʼṹ
*/
typedef struct
{
	char friendly_name[128];           ///Airplayն˵ʾƣiPhone/IPad豸Airplayն˵
	int  framerate;                    ///ȡֵΧ15-60; >60Ϊ60  <15Ϊ15
	int  resolution_type;              ///resolution_type ȡֵΧοBJAirResolutionType
	char password[256];				   ///Ͷ
	char licenseKey[1024];			   ///LicenseϢLicenseļжȡ
	//char itf_name[32];                 ///ӸýӿڻȡMACַ
	char mac_addr[32];                 ///ʽ:00:26:b9:52:7b:e0
    int airplay_flags;			       ///οBJ_AIRPLAY_FLAGS壬λ
	int max_session_nums;              ///nums ȡֵΧ1-9
	int republish_mode;                ///BJAir_RepublishType_Normal:normal repubsh BJAir_RepublishType_Remove_And_Publish:remove service and publish ȡֵΧο:BJAirRepublishType
    int log_level;                     ///־,ȡֵΧοBJAirplayLogLevel
    BJAirplayFunctionCbs_t callback;   ///ûصӿڣҪûʵ
}AirplayInitPara;

typedef void(*UserDefinePrint)(const char* message);

#ifdef  __cplusplus
extern "C" {
#endif

/** ʼBJAirplay SDK
*
*     ʼBJAirplay SDK
*     @param JNIEnv *env:Ӧôenv,sdk envʹ豸ӲϢ
*     @param initpara ʼṹ
*     @return    eg:@retval 0 BJAirplay SDKʼɹ @retval other: BJAirplay SDKʼʧܡ
*     @note   ӦҪͷŸûỰԴ
*/
BJ_AIRPLAY_API int  InitBJAirplay(JNIEnv *env,AirplayInitPara* initpara);

/** BJAirplay Ͷ
*
*     @param password
*     @note   øýӿڱ뱣֤ǰûκAirplayỰ,򷵻-1
*     @ret   0:success -1:not support
*/
BJ_AIRPLAY_API int SetAirplayPassword(const char *password);

/** BJAirplay ޸airplay
*
*     @param name
*/
BJ_AIRPLAY_API void ServiceRename(const char* name);

/** BJAirplay republish airplay
*
*     @param name
*/
BJ_AIRPLAY_API void ServiceRepublish();


/** ǿ˳ĳһ·Airplay
*
*     ǿ˳ĳһ·Airplay
*     @param playerId ŻỰID
*     @note   SDKڲὫairplayỰǿƽ
*/
BJ_AIRPLAY_API void  KickOut(uint32_t playerId);

BJ_AIRPLAY_API void UninitBJAirplay();

/** ̬־
*
*     ̬־
*     @param level ȡֵΧοBJAirplayLogLevel
*     @note
*/

BJ_AIRPLAY_API void SetAirplayLogLevel(int level);

#ifdef  __cplusplus
}
#endif

#endif
